﻿Imports System.IO

'修正履歴
'ssrDlog1 VB d1.02   2012/10/10 (発表）

'd1.03   2012/10/15
' ファイル設定のディフォールトフォルダ修正

'd1.04 2012/10/16
' Offline の格納サンプリング数値修正

'----------------------------------------------


'Port、ゼロ点等の設定データはssrOs1を共有


'ADunit　コミニケーション仕様
'COMポート　9600bps　
'コマンドは　　**Lf　の３文字    全てエコーバックを待つ

'ADunit　バージョンの確認　MM　新バージョン　ｄ***Lf　（旧バージョンは　a***Lf 対応不可）　
'A/Dからのデータ 10mS割り込み固定　ssrOs1　Tコマンド　T7　を利用 
'　ssrDlog　モードの設定　JS　スタートはssrOs1と同じ　ST　
'　　　データ　####Lf　　　下位1桁：レンジ　0,1,2　　EEPROMメモリ内格納

'ADunit側変更点
'　コマンド関連　MM　R3　KS　KT　KI　KS　KP　KL　JS 　　
'　オートレンジ　ADデータ　EEPROM格納　ADデータ転送　####Lf　　

'電圧値要求　　　
'　QQ　　変更　　　　応答 データ　####Lf　　R3の時　下位1桁：レンジ　0,1,2

'レンジ
'	R0,R1,R2:Range 0.2,　2,　20 V/F 
'　 R3:Auto　追加　-----レンジ切り替えはADunit内


'オフラインスタート   KS（PB3によるスイッチ） 

'オフライン解除　     KP　 PCの立ち上げ時設定

'オフラインデータ要求　KL　応答 データ　####Lf　で１つづつADunit内でインクリメント　下位1桁：レンジ　0,1,2
'　　１００点　途中で終了は　FFFFLf　
'    インターバル設定　KILf　に続き　ddddddddLf　 32bit 10mS単位のデータインターバル
'　　AD設定値要求　KT　応答　ddddddddLf　 ADunit内では平均処理なし　
'       24時間　86.4ksec　8,640,000　インターバル　　最大１年
'ADunit　接続の確認---オフライン測定自動Runとの区別　　コマンド  PUを使用


'エクセルでの最小自乗法　
'①　求めたい実験データを二列に表示
'②  グラフツール呼び出し　
'③　グラフの種類で散布図のデータポイントを平滑線で繋いだ散布図を選択。
'④　完了をクリック、するとグラフが表示。
'⑤　グラフ上のプロットされた点の上で右クリック→近似曲線の追加
'⑥　近似曲線メニューを選ぶ
'⑦  グラフに数式を表示するをチェック


'シリアルポートバッファを16倍に　---最大4096*16=64k　64秒　　





Public Class Form1

    Dim Version As String = "d1.03"
    Dim Uversion As String  ' ADunit Version

    Dim Start_F As Integer = 0 ' 測定開始の時のADデータをADpにセット

    Dim Measure As Integer
    Dim Tscale As Single  '10mS単位　1ドット　T軸時間


    Dim TpointInc As Single ' 時間軸スキップコマ
    Dim Tpoint As Single '時間軸位置
    Dim Tpoint_P As Single '前の時間軸位置
    Dim AccCnt As Integer ' 平均回数
    Dim AccCntB As Integer

    Dim RdChr(6) As Char



    Dim AD(66000) As String 'AD生データ(平均計算後 単位　V）
    Dim Result(66000) As String

    Dim ADi As Integer

    Dim AccAD As Single

    Dim ClbData(501) As String
    Dim CalData(501) As String

    Dim iAD As Integer 'AD 701点の格納
    Dim Zero As Integer
    Dim ZeroR0 As String ' レンジ０の　Zero点　--ファイルに格納 10進数変換後
    Dim ZeroR1 As String
    Dim ZeroR2 As String

    Dim Vref As String ' 基準電圧点　--ファイルに格納 10進数変換後
    Dim Kfactor As Single  ' A/D データの補正係数　　真値＝（A/DデーターZeor点）＊K   100/Full slace
    Dim SoftZero As Single = 0
    Dim SoftZero_Req As String = ""


    Dim SetDir As String = "" ' iniファイルのフォルダ

    Dim ParaFile As String = "" ' 　パラメータファイル
    Dim ParaFileDir As String = "" ' 　パラメータファイルのフォルダ

    Dim DataDir As String = "" '　波形データファイルのフォルダ
    Dim DataFile As String
    Dim DataNo As String = ""

    Dim CurrentF As String

    Dim PortNo As String

    'ssrDlog 専用
    Dim Range As Integer

    Dim ax(10) As Single

    Dim FitMode As String = "x" '

    Dim Xdim As Integer 'n次曲線の次元数


    Dim Yposition As Single ' 0-400 ドット換算係数
    Dim Yzero As Integer ' zero点位置スケール外は　－
    Dim Ydiv As Integer '  Yscale の１Divのポイント数---ユーザ入力　40- 200 範囲外は0

    Dim Page As Integer = 0  ' Auto Stop のページ数　0は無限
    Dim Cpath As String
    Dim imgPath As String
    Dim SCimg As String
    Private _shellExecute As Long

    Private Property ShellExecute(ByVal p1 As Integer, ByVal p2 As String, ByVal strFilePath As String, ByVal vbNullString As String, ByVal p5 As String, ByVal p6 As Object) As Long
        Get
            Return _shellExecute
        End Get
        Set(ByVal value As Long)
            _shellExecute = value
        End Set
    End Property

    Private Property SW_SHOWNORMAL As Object
    Private Function CheckPara() As String '  正常　は　nul　　
        Dim a As Single
        Try
            a = CSng(TextBoxFscale.Text)
            If TextBoxBase.Text <> "" Then a = CSng(TextBoxBase.Text)
            a = CSng(TextBoxBscale.Text)
            a = CSng(TextTime.Text)
            a = CSng(TextBoxMean.Text)
            a = CSng(TextBoxSampling.Text)
            If TextBoxAutoStop.Text <> "" Then a = CSng(TextBoxAutoStop.Text)

        Catch ex As Exception
            MessageBox.Show("Error! 設定が不適当です。")
            Return "Error"

        End Try
        Return ""
    End Function




    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        Iniset()
        Cpath = Application.UserAppDataPath
        imgPath = Cpath + "\Dimage.bmp"
        SCimg = Cpath + "\Zimage.bmp"

        If My.Computer.FileSystem.FileExists(imgPath) Then
        Else

            Dim bmp As New Bitmap(PictureBoxD.Width, PictureBoxD.Height)
            bmp.Save(imgPath, System.Drawing.Imaging.ImageFormat.Bmp)
        End If
        PictureBoxD.Image = New Bitmap(imgPath)

        If My.Computer.FileSystem.FileExists(SCimg) Then
        Else
            Dim bmp As New Bitmap(PictureBoxD.Width, PictureBoxD.Height)
            bmp.Save(SCimg, System.Drawing.Imaging.ImageFormat.Bmp)
        End If
        PictureBoxZ.Image = New Bitmap(SCimg)
        ScaleDraw("full")


    End Sub
    Private Sub Iniset()

        '設定ファイルを　set_Dlog.ini　とする。

        Dim SetPara As String = Application.UserAppDataPath + "\Set_Dlog.ini"

        If My.Computer.FileSystem.FileExists(SetPara) Then

            Try
                Using f = New IO.StreamReader(SetPara, System.Text.Encoding.Default)

                    ComboBoxPort.Text = f.ReadLine()
                    ZeroR0 = f.ReadLine()
                    ZeroR1 = f.ReadLine()
                    ZeroR2 = f.ReadLine()
                    Vref = f.ReadLine()
                    ParaFile = f.ReadLine()
                    DataDir = f.ReadLine()
                    DataFile = DataDir
                    TextBoxSet.Text = ParaFile
                    TextBoxData.Text = DataFile

                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try
            LoadPara()
        Else
            ScaleSet()
            Dim Dir As String = "C"
            MsgBox("最初にSetメニューの中の calibration （Zero と 1.85V veference）の設定を行ってください。")
        End If

    End Sub


    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click


        If CheckPara() = "Error" Then GoTo Abort
        ScaleSet()

        If Vref = "" Or ZeroR1 = "" Then
            MsgBox("Setメニューの中の　Calibration が必要です。")
            GoTo Abort
        End If
        If Measure = 0 Then
            If RadioButtonNormal.Checked = True Then
                Start()
                Measure = 1
            Else
                If MsgBox("Offline measurement is set.", 1) = 2 Then GoTo Abort
                SerialPort.PortName = ComboBoxPort.Text
                SerialPort.DtrEnable = True
                SerialPort.RtsEnable = True
                SerialPort.Open()
                Command("KP")
                Command("T7")
                Command("R" & CStr(Range))
                Command("JS")
                Command("KI")
                Dim num As Integer = CInt(TextBoxSampling.Text) * 100
                Dim str As String = Convert.ToString(num, 16)
                Send8Ch(str)
                Command("KS")
                SerialPort.Close()
            End If
        End If
Abort:
    End Sub

    Dim ADmodel As String = "d"
    Dim ADmodel_B As String = ""

    Private Sub Start()

        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()

        ADi = 0
        MarkP = 0
        MarkF = ""
        TextBoxMark.Text = ""

        Command("KP")
        Command("MM")
        Dim a As String = SerialPort.ReadLine
        ADmodel = Mid(a, 1, 1)
        If ADmodel <> "d" And ADmodel_B <> ADmodel Then
            MsgBox("ADunitが旧バージョンです。　正常に動作しませんので、PICを交換してください。")
            ADmodel_B = ADmodel
        End If

        Ini_Plot()

        Command("T7")
        Command("JS")
        Command("R" & CStr(Range))

        ButtonStart.ForeColor = Color.Red
        ButtonStart.Text = "Measure"

        Command("KP")
        Command("ST")

        Timer1.Enabled = Enabled

        AccAD = 0

        Start_F = 1
Abort:
    End Sub

    Dim TimeFIx As Integer '---1点表示　時間軸長さ（ポイント）
    Private Sub Ini_Plot()
        Page = 0
        If TextBoxAutoStop.Text <> "" Then Page = CInt(TextBoxAutoStop.Text)
        CurveFitSet()

        Tscale = CSng(TextTime.Text)  ' 
        TimeFIx = 0
        Select Case ComboBoxTime.Text
            Case "Sec/div"
            Case "Min/div"
                Tscale = Tscale * 60
            Case "Hour/div"
                Tscale = Tscale * 3600
            Case "Day/div"
                Tscale = Tscale * 3600 * 24
            Case "Mark/div"
                TimeFIx = CInt(100 / Tscale)

        End Select
        TpointInc = CSng(Mean) / Tscale

        Mean_B = 0
        Tpoint = 1

        If TimeFIx > 0 Then
            Tpoint_P = 0
            Tpoint = CSng(TimeFIx)
        End If

        Kfactor = 1.85 / ((CSng(Vref) - CSng(ZeroR1)) * 10)
        ScaleDraw("full")
        TextBoxCtime.Text = "0"

        Scroll_f = 0

    End Sub

    Private Sub ScaleDraw(ByVal Fill As String)


        Dim gD As Graphics = Graphics.FromImage(PictureBoxD.Image)
        Dim gZ As Graphics = Graphics.FromImage(PictureBoxZ.Image)

        Dim b As New SolidBrush(Color.FromArgb(250, 255, 255, 230))

        If Fill = "full" Then gZ.FillRectangle(b, 1, 1, 200, 400)
        gD.FillRectangle(b, 1, 1, 500, 400)

        Dim p As New Pen(Color.Blue, 1)
        gD.DrawRectangle(p, 0, 0, 501, 401)
        gZ.DrawRectangle(p, 0, 0, 200, 401)
        For x = 1 To 4
            gD.DrawLine(p, x * 100, 1, x * 100, 400)
        Next x
        For y = 1 To 3
            gD.DrawLine(p, 1, y * 100, 500, y * 100)
        Next y
        '        Dim gp As New Pen(Color.Green, 1)
        Dim gp As New Pen(Color.FromArgb(240, 190, 190, 0))
        If Ybase < 400 And Ybase > 0 Then gD.DrawLine(gp, 1, Ybase, 500, Ybase)
        gD.Dispose()
        gZ.Dispose()
        PictureBoxD.Invalidate()
        PictureBoxZ.Invalidate()

    End Sub



    Private Sub Pause()

        Timer1.Enabled = False

        SerialPort.Write("P")  '-----Pを送信し、エコーを待つ
Repeat:

        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        If RdChr(0) <> "P" Then GoTo Repeat
        SerialPort.Write("U")
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        SerialPort.Write(ControlChars.Lf)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)


        ButtonStart.ForeColor = Color.Black
        ButtonStart.Text = "Start"
        SerialPort.Close()
    End Sub

    ' RdChr(0) & RdChr(1)の16進表記文字列を10進数に変換　&H0～＆HF以外の数値は256とする。
    Private Function RecNum() As Integer
        Dim num16 As Integer
        If ((RdChr(0) > "/" And RdChr(0) < ":") Or (RdChr(0) > "@" And RdChr(0) < "G")) And _
           ((RdChr(1) > "/" And RdChr(1) < ":") Or (RdChr(1) > "@" And RdChr(1) < "G")) Then

            Dim a As String = RdChr(0) & RdChr(1)
            Dim b As String = "&H" + Mid(a, 1, 2)
            num16 = CInt(b)
        Else
            num16 = 256
        End If
        Return num16
    End Function

    ' ADunitからの16進表記文字列を10進数に変換 　下位1桁：レンジ　0,1,2　&H0～＆HF以外の数値は 999,9999 とする。
    Private Function ADHex10(ByVal a As String) As Integer
        Dim out As Integer

        Dim i As Integer = Len(a)
        Dim r As String = Mid(a, i, 1)
        a = Mid(a, 1, i - 1)
        i = i - 1
        Dim b As String
        Do While i > 0
            b = Mid(a, i, 1)
            If b < "0" Or (b > "9" And b < "A") Or b > "F" Then Return 999999
            i = i - 1
        Loop
        b = "&H0" & a
        out = CInt(b) / 4
        Select Case r
            Case "0"
                out = out - CInt(ZeroR0)
            Case "1"
                out = (out - CInt(ZeroR1)) * 10
            Case "2"
                out = (out - CInt(ZeroR2)) * 100
        End Select

        out = out - SoftZero
        Return out  '最大値　102,300


    End Function


    Private Sub Command(ByVal a As String)  'aは2文字　　　エコーバックを待つ
        Dim c1(1) As Char
        Dim c2(1) As Char
        Dim c3(1) As Char

        SerialPort.Write(Mid(a, 1, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c1, 0, 1)

        SerialPort.Write(Mid(a, 2, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c2, 0, 1)

        SerialPort.Write(ControlChars.Lf)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c3, 0, 1)
        RdChr(0) = c1(0)
        RdChr(1) = c2(0)
    End Sub
    Private Sub Send8Ch(ByVal a As String)
        Dim c(1) As Char
        Dim t As Integer
        Dim d As String = ""
        t = 8 - a.Length
        While t > 0
            d = d + "0"
            t = t - 1
        End While
        d = d + a
        For i = 1 To 8
            SerialPort.Write(Mid(d, i, 1))
            While SerialPort.BytesToRead < 1
            End While
            SerialPort.Read(c, 0, 1)
        Next i
        SerialPort.Write(ControlChars.Lf)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c, 0, 1)
    End Sub


    Private Function GetVin(ByVal Range As String) As String   '  生電圧値取得　４回平均　ゼロ点バイアスはそのまま
        Command(Range)
        Dim a As Integer = 0
        For i = 1 To 4
            Command("QQ")
            Do While SerialPort.BytesToRead < 2
            Loop
            SerialPort.Read(RdChr, 0, 2)
            Dim b As Integer = RecNum()
            Do While SerialPort.BytesToRead < 3
            Loop
            SerialPort.Read(RdChr, 0, 3)
            b = (b * 4 + RecNum() / 64)
            a = a + b
        Next i
        a = a / 4
        Return CStr(a)
    End Function
    Dim ADn As Integer ' 現在表示位置データ　ｙ軸　0-400
    Dim ADp As Integer ' 前の表示位置
    Dim OverF As String 'Over Range
    Dim ADr As Single ' Curve fit 前生データ---ファイル格納データ　レンジデータ込
    Dim ADc As Single ' Curve fit 後
    Dim ADu As Integer 'ADunit 生データ



    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim gD As Graphics = Graphics.FromImage(PictureBoxD.Image)

        '　波形は緑色プロット　ただし　スケールオーバを赤色表示　レンジR2で20V越え

        Timer1.Enabled = False

        'シリアルポートバッファオーバの検出

        Dim st As String = ""

Repeat:
        If ADmodel = "d" Then
            If SerialPort.BytesToRead < 5 Then GoTo Abort1
            Dim ADuSt = SerialPort.ReadLine()
            TextBoxX.Text = ADuSt
            ADu = ADHex10(ADuSt)
            ADr = CSng(ADu)
        Else
            ' 旧バージョン対応
            If SerialPort.BytesToRead < 2 Then GoTo Abort1
            SerialPort.Read(RdChr, 0, 2)
            ADu = RecNum()
            ADr = CSng(ADu) * 4 - 512
        End If

        If st = "END" Then GoTo Repeat

        If ADu = 999999 Then '  Error
            ButtonStart.ForeColor = Color.Red
            ButtonStart.Text = "Error"
            GoTo Abort1
        End If

        If ADr > 100000 Then OverF = "over"

        If CInt(Mean) = 1 Then

        Else ' -----単純平均　
            AccAD = AccAD + ADr
            Mean_B = Mean_B + 1
            If CInt(Mean) = Mean_B Then
                ADr = AccAD / Mean_B
                AccAD = 0
                Mean_B = 0
            Else
                GoTo Repeat
            End If

        End If
        ADr = ADr * Kfactor '  1unit=1V

        If SoftZero_Req <> "" Then
            SoftZero_Req = ""
            SoftZero = ADr
        End If
        TextBoxmV.Text = CStr(ADr * 1000)
        ADr = ADr - SoftZero


        AD(ADi) = CStr(ADr)


        If TimeFIx = 0 Then
            If MarkF <> "" Then
                MarkF = ""
                Mark(MarkP) = ADi
                MarkP = MarkP + 1
            End If
            st = DrawData("")
            Result(ADi) = CStr(ADc)

            If ADi < 65531 Then ADi = ADi + 1
        Else
            If MarkF <> "" Then
                st = DrawData("")
                Result(ADi) = CStr(ADc)
                MarkF = ""
                MarkP = MarkP + 1
                ADi = ADi + 1
            End If

        End If
        GoTo Repeat
Abort1:
        If st = "END" Then
            Pause()
            If DataDir <> "" Then SaveData()
            Measure = 0
        Else
            Timer1.Enabled = Enabled
        End If

    End Sub
    Dim Scroll_f As Integer  ' スクロール時　測定開始のみデータを１点飛ばす 

    Private Function DrawData(ByVal p As String) As String ' 強制終了 　END　
        Dim gD As Graphics = Graphics.FromImage(PictureBoxD.Image)
        ADc = 0
        Try
            Select Case FitMode
                Case "x"
                    ADc = ADr ' 単位　V　換算 

                Case "ax+b"
                    ADc = ax(1) * ADr + ax(2)

                Case "ax*(n)"
                    ADc = ax(Xdim + 1)
                    Dim i As Integer = Xdim
                    Do While i > 0
                        ADc = ADc + ax(i) * (ADr ^ i)
                        i = i - 1
                    Loop

                Case "aLog(x)"
                    If ADr > 0 Then
                        ADc = ax(1) * Math.Log(ADr) + ax(2)
                    Else
                        ButtonStart.Text = "Error"
                        ButtonStart.ForeColor = Color.Red
                    End If


                Case "ax*(b)" ' X ^ Y = e ^ (Y * ln(X))")
                    If ADr > 0 Then
                        ADc = ax(1) * Math.Exp(ax(2) * Math.Log(ADr))
                    Else
                        ButtonStart.Text = "Error"
                        ButtonStart.ForeColor = Color.Red
                    End If
                Case "ae*(bx)"
                    If ADr > 0 Then
                        ADc = ax(1) * Math.Exp(ax(2) * ADr)
                    Else
                        ButtonStart.Text = "Error"
                        ButtonStart.ForeColor = Color.Red
                    End If
            End Select

            ADp = ADn
            ADn = 400 - (CInt(ADc * Yposition) + Yzero)
            If TimeFIx > 0 Then ADp = ADn
        Catch ex As Exception
            ButtonStart.Text = "Error"
            ButtonStart.ForeColor = Color.Red
        End Try

        If ADn < 1 Then ADn = 1
        If ADn > 400 Then ADn = 400

        If Start_F = 1 Then
            Start_F = 0
            ADp = ADn
            If TimeFIx = 0 Then GoTo Abort
        End If

        If Tpoint = 1 And Scroll_f = 0 Then Tpoint_P = 0

        Dim Tn As Integer = CInt(Tpoint)

        Dim Tp As Integer = CInt(Tpoint_P)


        If OverF = "" Then
            gD.DrawLine(Pens.Red, Tp, ADp, Tn, ADn)

        Else
            gD.DrawLine(Pens.Orange, Tp, ADp, Tn, ADn)

            OverF = ""
        End If
        Tpoint_P = Tpoint
        If TimeFIx = 0 Then
            Tpoint = Tpoint + TpointInc
        Else
            Tpoint = Tpoint + 100 / Tscale

        End If


        If Tpoint > 501 Then '-----画面エッジ処理

            Scroll_f = 1

            If p <> "" Then  ' 再計算
                If MessageBox.Show("Next Page ?", "", MessageBoxButtons.YesNo) = DialogResult.No Then
                    GoTo AbortEnd
                End If
            Else
                If Page > 0 Then
                    Page = Page - 1
                    If Page = 0 Then GoTo AbortEnd
                End If
            End If

            Dim img = New Bitmap(PictureBoxD.Width, PictureBoxD.Height)
            img = PictureBoxD.Image

            Dim gZ As Graphics = Graphics.FromImage(PictureBoxZ.Image)
            Dim rect As New Rectangle(301, 1, 500, 400)
            gZ.DrawImage(img, 1, 1, rect, GraphicsUnit.Pixel)

            gZ.Dispose()
            PictureBoxZ.Invalidate()

            Tpoint_P = 0
            'Tpoint = 1
            Tpoint = TpointInc
            If TimeFIx > 0 Then
                Tpoint_P = 0
                Tpoint = CSng(TimeFIx)
            Else
                TextBoxCtime.Text = CStr(CSng(TextTime.Text) * 5 + CSng(TextBoxCtime.Text))

            End If
            ScaleDraw("half")
        End If

Abort:
        gD.Dispose()
        PictureBoxD.Invalidate() 'Imageプロパティに描画した後に再描画しないと更新された画像が表示されない）
        Return " "

AbortEnd:

        gD.Dispose()
        PictureBoxD.Invalidate()
        Return "END"

    End Function
    Private Sub SaveData()

        '----ファイルセーブ　　デスクトップ　ssrDlog.csv 
        'タイトル、日時, 1point時間(sec)、データ　単位　V　文字列

        Dim a As Integer = DataFile.IndexOf(".")
        Dim b As Integer = DataFile.IndexOf("_")
        If a - 1 = b And DataNo = "" Then DataNo = "0"
        If DataNo <> "" Then

            DataNo = CStr(CInt(DataNo) + 1)
            CurrentF = Mid(DataFile, 1, a)
            CurrentF = CurrentF + DataNo + ".csv"
        Else
            CurrentF = DataFile
        End If
        TextBoxData.Text = CurrentF

        SaveData_main(CurrentF, CSng(Mean) / 100, ADi)

    End Sub

    Sub SaveData_main(ByVal fname As String, ByVal sample As Single, ByVal ai As Integer)

        Dim dd As Date = Date.Now
        Dim d As String = dd.ToString("g")

        Dim Ts As String = CStr(Single.Parse(sample))
        Dim NoAD As String = CStr(ai)

        Try
            Dim f = New IO.StreamWriter(fname, False, System.Text.Encoding.Default)
            f.WriteLine("Data with ssrDlog1")
            f.WriteLine("Date," + d)
            f.WriteLine("Sampling Time(Sec)," + Ts)
            f.WriteLine("Number of Data," + NoAD)
            f.WriteLine("Curve fit,," + TextBoxCurve.Text)
            f.WriteLine("Input(Volt),Mark,Result")
            Dim j As Integer = 0
            For i = 0 To (ADi - 1)
                If MarkP > j And Mark(j) = i Then
                    j = j + 1
                    f.WriteLine(AD(i) + "," + CStr(j) + "," + Result(i))
                Else
                    f.WriteLine(AD(i) + ",," + Result(i))
                End If

            Next i
            f.Close()
        Catch ex As Exception
            ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
        End Try

    End Sub


    Private Sub CurveFitSet()

        ' y=x
        ' y = 2.0161x - 0.2763
        ' y = -2E-05x4 + 0.0008x3 - 0.002x2 + 1.8969x + 0.2187
        ' y = 19.183ln(x) - 16.766
        ' y = 1.9622x1.0055
        ' y = 5.9584e0.0898x

        Try
            Dim a As String = TextBoxCurve.Text
            Dim b As Integer = a.Length
            Dim c As Integer = a.IndexOf(" ")
            Dim st As String

            Do While c > -1
                If c = 0 Then
                    a = Mid(a, 2, b - 1)
                Else
                    If c = b - 1 Then
                        a = Mid(a, 1, b - 1)
                    Else
                        a = Mid(a, 1, c) & Mid(a, c + 2, b - c - 1)
                    End If
                End If
                b = a.Length
                c = a.IndexOf(" ")
            Loop
            c = a.IndexOf("=")
            If c = -1 Then GoTo SetError
            a = Mid(a, c + 2, b - c - 1)
            If a = "x" Then
                FitMode = "x"
                GoTo Abort
            End If
            b = a.IndexOf("ln")
            If b > -1 Then
                FitMode = "aLog(x)"
                ax(1) = Single.Parse(Mid(a, 1, b))
                ax(2) = Single.Parse(Mid(a, b + 6, a.Length - b - 5))
                GoTo Abort
            End If
            b = a.IndexOf("e")
            If b > -1 Then
                FitMode = "ae*(bx)"
                ax(1) = Single.Parse(Mid(a, 1, b))
                ax(2) = Single.Parse(Mid(a, b + 2, a.Length - b - 2))
                GoTo Abort
            End If
            b = a.IndexOf("x")
            If b > -1 Then
                If a.Length = (b + 1) Then
                    FitMode = "ax+b"
                    ax(1) = Single.Parse(Mid(a, 1, b))
                    ax(2) = 0
                    GoTo Abort
                End If
                st = Mid(a, b + 2, 1)
                If st = "+" Or st = "-" Then
                    FitMode = "ax+b"
                    ax(1) = Single.Parse(Mid(a, 1, b))
                    ax(2) = Single.Parse(Mid(a, b + 2, a.Length - b - 1))
                    GoTo Abort
                End If
                st = Mid(a, b + 3, 1)
                If st <> "-" And st <> "+" Then
                    FitMode = "ax*(b)"
                    ax(1) = Single.Parse(Mid(a, 1, b))
                    ax(2) = Single.Parse(Mid(a, b + 2, a.Length - b - 1))
                    GoTo Abort
                End If
                FitMode = "ax*(n)"
                Xdim = Mid(a, b + 2, 1)
                c = 1
                Do While c <= Xdim
                    ax(c) = 0
                    b = a.IndexOf("x")
                    If b > 0 Then
                        If c < Xdim Then
                            If (CInt(Mid(a, b + 2, 1)) = (Xdim - c + 1)) Then
                                ax(c) = Single.Parse(Mid(a, 1, b))
                                If a.Length > b + 2 Then a = Mid(a, b + 3, a.Length - b - 2)
                            End If
                        End If
                        If c = Xdim Then
                            ax(c) = Single.Parse(Mid(a, 1, b))
                            If a.Length > b + 2 Then a = Mid(a, b + 2, a.Length - b - 1)
                        End If
                    End If
                    c = c + 1
                Loop
                ax(c) = 0
                If b >= 0 Then ax(c) = Single.Parse(a)
                GoTo Abort
            End If
        Catch ex As Exception
        End Try
SetError:
        MessageBox.Show("Error !  設定をやり直してください。")

Abort:
    End Sub


    Private Sub PortToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortToolStripMenuItem1.Click

        ComboBoxPort.Items.Clear()

        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBoxPort.Items.Add(sp)
            ComboBoxPort.Text = sp
        Next



    End Sub

    Private Sub ComboBoxPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxPort.SelectedIndexChanged

    End Sub

    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStop.Click
        If Measure = 1 Then
            Pause()
            If DataDir <> "" Then SaveData()

        End If
        Measure = 0
    End Sub


    Private Sub TextTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextTime.TextChanged

    End Sub


    Private Sub CurveFit_x_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        FitMode = "x"
    End Sub
    Dim Mark(100) As Integer
    Dim MarkP As Integer
    Dim MarkF As String = ""

    Private Sub ButtonMark_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMark.Click
        'ファイル内にマーク（通し番号）を書き込む
        If Measure = 1 Then
            If MarkP < 100 Then
                Mark(MarkP) = ADi
                TextBoxMark.Text = CStr(MarkP + 1)
                MarkF = "mark"
            End If
        Else
            MarkP = 0
            TextBoxMark.Text = ""
        End If

    End Sub

    Dim Ybase As Integer  ' Ini ファイル格納
    Private Sub ScaleSet()
        If CheckPara() = "Error" Then GoTo Abort
        Dim yf As Single = CSng(TextBoxFscale.Text)
        Dim yb As Single = CSng(TextBoxBscale.Text)
        Yposition = 400 / (yf - yb)
        Yzero = 0 - yb * Yposition
        If yf < yb Then
            MessageBox.Show("Error")
            GoTo Abort
        End If
        Ybase = 0
        If TextBoxBase.Text <> "" Then
            Dim yl As Single = CSng(TextBoxBase.Text)
            If yf < yl Then
                MessageBox.Show("Error")
                GoTo Abort
            End If
            Ybase = CInt(400 - (Yposition * yl + Yzero))  ' 範囲外は表示しない
        End If
        ButtonScaleSet.ForeColor = Color.Black
Abort:
    End Sub


    Private Sub ButtonScaleSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonScaleSet.Click

        ScaleSet()

    End Sub

    Private Sub TextBoxFscale_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFscale.TextChanged
        ButtonScaleSet.ForeColor = Color.Red
    End Sub
    Private Sub TextBoxBscale_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBscale.TextChanged
        ButtonScaleSet.ForeColor = Color.Red
    End Sub

    Private Sub CurveFit_AeX_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub
    Dim Mean As String
    Dim Mean_B As Integer

    Private Sub TextBoxMean_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMean.TextChanged
        If Measure = 0 Then
            Mean = TextBoxMean.Text
        Else
            TextBoxMean.Text = Mean
        End If


    End Sub


    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

            Dim SetPara As String = Application.UserAppDataPath + "\Set_Dlog.ini"
            Try
            Using f = New IO.StreamWriter(SetPara, False, System.Text.Encoding.Default)

                f.WriteLine(ComboBoxPort.Text)
                f.WriteLine(ZeroR0)
                f.WriteLine(ZeroR1)
                f.WriteLine(ZeroR2)
                f.WriteLine(Vref)
                f.WriteLine(ParaFile)
                f.WriteLine(DataDir)

 
            End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try

        Dim result As DialogResult = MessageBox.Show("Save setting file ?", "", MessageBoxButtons.YesNo)
        If result = DialogResult.Yes Then SavePara()

    End Sub



    Private Sub ZeroToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZeroToolStripMenuItem.Click
        If Measure = 0 Then
            SerialPort.PortName = ComboBoxPort.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Short-circuit Input.  Ready ?", 1) = 1 Then
                ZeroR0 = GetVin("R0")
                ZeroR1 = GetVin("R1")
                ZeroR2 = GetVin("R2")
            End If
            SerialPort.Close()
            TextBoxComment.Text = "Zero=" + CStr(CInt(ZeroR0) - 512)
        End If
    End Sub


    Private Sub Reference185VToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Reference185VToolStripMenuItem.Click
        If Measure = 0 Then
            SerialPort.PortName = ComboBoxPort.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Input Standard Voltage.  Ready ?", 1) = 1 Then
                Vref = GetVin("R1")
                TextBoxComment.Text = "Vref=" + CStr(CInt(Vref) - 512)
            End If
            SerialPort.Close()

        End If
    End Sub

    Private Sub ComboBoxRange_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxRange.SelectedIndexChanged
        Dim a As Integer = Range
        Select Case ComboBoxRange.Text
            Case "0.2V"
                a = 0
            Case "2V"
                a = 1
            Case "20V"
                a = 2
            Case "Auto"
                a = 3
        End Select
        If Measure = 0 Then
            Range = a
        Else
            If a <> Range Then
                Range = a
                Pause()
                Start()
            End If
        End If
    End Sub

    Private Sub PictureBoxD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxD.Click

        Dim p As Point = PointToClient(System.Windows.Forms.Cursor.Position)
        Dim g As Graphics = PictureBoxD.CreateGraphics()

        Dim x As Integer = p.X
        x = x - 295

        Dim y As Integer = p.Y
        y = y - 130

        Dim V As Single = (400 - Yzero - y) / Yposition

        Dim DspXY As String = " " & CStr(V)
         Dim fnt As New Font("MS UI Gothic", 10)
        g.DrawString(DspXY, fnt, Brushes.Green, x, y)
        g.DrawLine(Pens.Black, x - 2, y, x + 2, y)
        fnt.Dispose()
        g.Dispose()



    End Sub

    Private Sub ComboBoxTime_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTime.SelectedIndexChanged

    End Sub

    Private Sub PictureBoxZ_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxZ.Click
        Dim p As Point = PointToClient(System.Windows.Forms.Cursor.Position)
        Dim g As Graphics = PictureBoxZ.CreateGraphics()

        Dim x As Integer = p.X
        x = x - 94

        Dim y As Integer = p.Y
        y = y - 130

        Dim V As Single = (400 - Yzero - y) / Yposition

        Dim DspXY As String = " " & CStr(V)

        Dim fnt As New Font("MS UI Gothic", 10)
        g.DrawString(DspXY, fnt, Brushes.Green, x, y)
        g.DrawLine(Pens.Black, x - 2, y, x + 2, y)
        fnt.Dispose()
        g.Dispose()
    End Sub

    Private Sub ComboBoxCfit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim a As String = FitMode

        If Measure = 0 Then
            FitMode = a
        Else
            If a <> FitMode Then
                FitMode = a
                Pause()
                Start()
            End If
        End If

    End Sub

    Private Sub CurveFit_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)


    End Sub

    Private Sub CurveFit_New_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub VersionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VersionToolStripMenuItem.Click
        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()
        Command("MM")

        MsgBox("（株）島津総合科学研究所" + ControlChars.Lf + "ssrDlog1 System version = " + Version + ControlChars.Lf + _
               "ADunit Version = " + SerialPort.ReadLine)

        SerialPort.Close()
    End Sub

    Private Sub OnLineManualToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OnLineManualToolStripMenuItem.Click


        Dim d As String = " http://www.shimadzu.co.jp/ssr/etc/ssrDlog/help_dlog1.pdf"


        Help.ShowHelp(TextBoxComment, d)

    End Sub

    Private Sub ADunitCheckToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ADunitCheckToolStripMenuItem.Click
        Dim a As String
        Dim b As String
        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()

Repeat:
        a = InputBox("Input Command ")
        If a <> "" Then
            Command(a)
            b = a + " / " + RdChr(0) + RdChr(1)
            If a = "QQ" Or a = "MM" Then b = b + " / " + SerialPort.ReadLine

            TextBoxComment.Text = b
            GoTo Repeat
        End If
        SerialPort.Close()
    End Sub


    Private Sub TextBoxSampling_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxSampling.TextChanged

    End Sub

    Private Sub ComboBoxADmode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub RadioButtonOffline_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonOffline.CheckedChanged

    End Sub

    Private Sub RadioButtonNormal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonNormal.CheckedChanged

    End Sub

    Private Sub ButtonRePlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRePlay.Click

        Dim fname As String

        If CheckPara() = "Error" Then GoTo AbortEND

        If Measure = 0 Then
            If RadioButtonNormal.Checked = True Then
                '  ----------------------ファイルの再計算            
Again:
                If DataDir = "" Then DataDir = Application.UserAppDataPath
                Dim ofd As New OpenFileDialog()
                ofd.FileName = ""
                ofd.InitialDirectory = DataDir
                ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
                ofd.FilterIndex = 2
                ofd.Title = "読みだすファイル名を設定してください"
                ofd.CheckFileExists = False
                If ofd.ShowDialog() = DialogResult.OK Then
                    fname = ofd.FileName
                Else
                    GoTo AbortEND
                End If

                MessageBox.Show("Mean の設定値がファイルの中の値に変更されます。")

                Dim NoAD As Integer

                Try
                    Dim f = New IO.StreamReader(fname, System.Text.Encoding.Default)
                    Dim st As String = f.ReadLine()
                    st = f.ReadLine()
                    st = f.ReadLine()
                    Dim ai As Integer = st.IndexOf(",")
                    st = Mid(st, ai + 2, st.Length - ai - 1)
                    TextBoxMean.Text = CStr(CSng(st) * 100)

                    st = f.ReadLine()
                    ai = st.IndexOf(",")
                    NoAD = CInt(Mid(st, ai + 2, st.Length - ai - 1))
 
                    st = f.ReadLine()
                    st = f.ReadLine()

                    Ini_Plot()
                    Start_F = 1
                    Do While NoAD > 0
                        st = f.ReadLine()
                        ai = st.IndexOf(",")
                        ADr = CSng(Mid(st, 1, ai))
                        If DrawData("repaly") = "END" Then
                            f.Close()
                            GoTo AbortEND
                        End If
                        NoAD = NoAD - 1
                    Loop
                    f.Close()
                Catch ex As Exception
                    ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
                End Try
            Else  '---------------------ADunit の格納データの再計算

                MessageBox.Show("Time scale と Mean の設定が ADunitから設定されます。")
                SerialPort.PortName = ComboBoxPort.Text
                SerialPort.DtrEnable = True
                SerialPort.RtsEnable = True
                SerialPort.Open()

                Command("KT")

                Dim adt As Integer = Convert.ToInt32(SerialPort.ReadLine(), 16)

                TextBoxMean.Text = CStr(adt)
                Dim a As Decimal
                a = Decimal.Parse(TextBoxMean.Text) / 100 'a　秒
                If a < 60 Then
                    TextTime.Text = CStr(a * 20)
                    ComboBoxTime.Text = "Sec/div"
                Else
                    If a < 3600 Then
                        TextTime.Text = CStr(a / 3)
                        ComboBoxTime.Text = "Min/div"
                    Else
                        If a < 86400 Then
                            TextTime.Text = CStr(a / 180)
                            ComboBoxTime.Text = "Hour/div"
                        Else
                            TextTime.Text = CStr(a / 4320)
                            ComboBoxTime.Text = "Day/div"
                        End If
                    End If
                End If

                Ini_Plot()

                ADi = 0
                Command("KL")
                Do While ADi < 100
                    Dim ADuSt As String = SerialPort.ReadLine()
                    If ADuSt = "FFFF" Then GoTo Abort
                    ADu = ADHex10(ADuSt)
                    ADr = CSng(ADu) * Kfactor
                    If ADu = 999999 Then '  Error
                        MsgBox("Error Port")
                        GoTo Abort
                    End If

                    If ADr > 100000 Then OverF = "over"
                    AD(ADi) = CStr(ADr)
                    If ADi = 0 Then Start_F = 1
                    DrawData("p")
                    ADi = ADi + 1
                Loop
Abort:

            SerialPort.Close()
                If MessageBox.Show("ADunit内のデータを格納しますか ?", "", MessageBoxButtons.YesNo) = DialogResult.Yes Then

                    fname = Application.UserAppDataPath
                    Dim ofd As New OpenFileDialog()
                    ofd.FileName = ""
                    ofd.InitialDirectory = fname
                    ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
                    ofd.FilterIndex = 2
                    ofd.Title = "格納するファイル名を設定してください"
                    ofd.CheckFileExists = False
                    If ofd.ShowDialog() = DialogResult.OK Then
                        fname = ofd.FileName
                    Else
                        GoTo AbortEND
                    End If

                    SaveData_main(fname, CSng(TextTime.Text) / 20, ADi)


                End If

            End If

        End If
AbortEND:

    End Sub


    Private Sub TextBoxBase_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBase.TextChanged
        ButtonScaleSet.ForeColor = Color.Red
    End Sub

    Private Sub Curve_Fit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Curve_Fit.Click

        Dim st As String = "Input curve fit Fomura as follows." + ControlChars.CrLf + _
                           "  y=x" + ControlChars.CrLf + _
                           "  y=2.1x-0.76" + ControlChars.CrLf + _
                           "  y=-0.3x4+1.08x3-0.2x2+1.9x+0.21" + ControlChars.CrLf + _
                           "  y=19.1ln(x)-16.7" + ControlChars.CrLf + _
                           "  y=1.96x1.0055" + ControlChars.CrLf + _
                           "  y=5.9e0.089x" + ControlChars.CrLf + " "

        st = InputBox(st)
        If st <> "" Then TextBoxCurve.Text = st
        CurveFitSet()
    End Sub


    Private Sub TextBoxSet_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxSet.TextChanged

    End Sub

    Private Sub TextBoxMark_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMark.TextChanged

    End Sub

    Private Sub TextBoxmV_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxmV.TextChanged

    End Sub


    Private Sub OpenDataFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NormalToolStripMenuItem.Click
        ' 連続ファイル名　　***_##.csv　　##=00～99
Again:
        Dim st As String = "File name　の設定" + ControlChars.CrLf + _
                           "名前の末尾にアンダーバー（　_　）の記号があるときは、Name_1.csv,　Name_2csv. --のように連続記憶。 " + ControlChars.CrLf + _
                           "_　が　無い場合は測定毎に同じファイルに上書き。"

        MessageBox.Show(st)

        If DataDir = "" Then DataDir = Application.UserAppDataPath
        Dim ofd As New OpenFileDialog()
        ofd.FileName = ""
        ofd.InitialDirectory = DataDir
        ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
        ofd.FilterIndex = 2
        ofd.Title = "格納するファイル名を設定してください"
        ofd.CheckFileExists = False
        If ofd.ShowDialog() = DialogResult.OK Then
            DataFile = ofd.FileName
            TextBoxData.Text = DataFile
            Dim i As Integer = DataFile.IndexOf(".")
            DataDir = DataFile
        Else
            GoTo Abort
        End If
        Dim a As Integer = DataFile.IndexOf(".")
        If a < 0 Then
            MessageBox.Show("Error！  .csv としてください")
            GoTo Again
        End If
        a = DataFile.IndexOf("_")
        If a = DataFile.Length - 5 Then
            DataNo = "0"
        Else
            DataNo = ""

        End If
Abort:
    End Sub

    Private Sub CloseDataFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OfflineToolStripMenuItem.Click

        TextBoxData.Text = ""
    End Sub
    Private Sub SetFile()
        ParaFileDir = ParaFile
        If ParaFileDir = "" Then ParaFileDir = Application.UserAppDataPath
        Dim ofd As New OpenFileDialog()
        ofd.FileName = ""
        ofd.InitialDirectory = ParaFileDir
        ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
        ofd.FilterIndex = 2
        ofd.Title = "設定ファイル名を設定してください"
        ofd.CheckFileExists = False
        If ofd.ShowDialog() = DialogResult.OK Then
            ParaFile = ofd.FileName
            ParaFileDir = ofd.FileName
        End If
        TextBoxSet.Text = ParaFile
    End Sub
    Private Sub SavePara()
        Try
            Using f = New IO.StreamWriter(ParaFile, False, System.Text.Encoding.Default)

                f.WriteLine(TextBoxFscale.Text)
                f.WriteLine(TextBoxUnit.Text)
                f.WriteLine(TextBoxBase.Text)
                f.WriteLine(TextBoxBscale.Text)
                f.WriteLine(TextBoxCurve.Text)
                f.WriteLine(ComboBoxRange.Text)
                f.WriteLine(TextBoxSampling.Text)
                f.WriteLine(TextTime.Text)
                f.WriteLine(ComboBoxTime.Text)
                f.WriteLine(TextBoxMean.Text)
                f.WriteLine(TextBoxAutoStop.Text)
                f.WriteLine(ParaFile)
                f.WriteLine(DataDir)

            End Using
        Catch ex As Exception
            ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
        End Try

    End Sub
    Private Sub LoadPara()
        If System.IO.File.Exists(ParaFile) Then
            Try
                Using f = New IO.StreamReader(ParaFile, System.Text.Encoding.Default)

                    TextBoxFscale.Text = f.ReadLine()
                    TextBoxUnit.Text = f.ReadLine()
                    TextBoxBase.Text = f.ReadLine()
                    TextBoxBscale.Text = f.ReadLine()
                    TextBoxCurve.Text = f.ReadLine()
                    ComboBoxRange.Text = f.ReadLine()
                    TextBoxSampling.Text = f.ReadLine()
                    TextTime.Text = f.ReadLine()
                    ComboBoxTime.Text = f.ReadLine()
                    TextBoxMean.Text = f.ReadLine()
                    TextBoxAutoStop.Text = f.ReadLine()
                    ParaFile = f.ReadLine()
                    DataDir = f.ReadLine()
                    DataFile = DataDir
                    TextBoxSet.Text = ParaFile
                    TextBoxData.Text = DataFile

                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
            End Try
            ScaleSet()

        Else
            MessageBox.Show("設定ファイル" + ParaFile + "がありません。")
        End If

    End Sub

    Private Sub OpenSetFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click

        SetFile()
        LoadPara()
    End Sub

    Private Sub SaveSetFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        SavePara()
    End Sub

    Private Sub SaveAsSetFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        SetFile()
        SavePara()

    End Sub

    Private Sub TextBoxUnit_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUnit.TextChanged

    End Sub

    Private Sub TextBoxAutoStop_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxAutoStop.TextChanged

    End Sub

    Private Sub TextBoxCtime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxCtime.TextChanged

    End Sub

    Private Sub ButtonZero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonZero.Click
        If Measure = 0 Then
            MessageBox.Show("Start中動作します。")
        Else
            SoftZero_Req = "req"
            ButtonZero.Text = "Efect"
        End If
    End Sub

    Private Sub ButtonFree_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFree.Click
        If Measure = 0 Then
            MessageBox.Show("Start中動作します。")
        Else
            SoftZero = 0
            ButtonZero.Text = "Set"
        End If
    End Sub

    Private Sub HelpToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripMenuItem.Click

    End Sub

    Private Sub ButtonUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUp.Click
        Try
            TextBoxFscale.Text = CStr(CSng(TextBoxFscale.Text) * 2)
            TextBoxBscale.Text = CStr(CSng(TextBoxBscale.Text) * 2)
            ScaleSet()

        Catch ex As Exception
            MessageBox.Show("Error! 不適当な設定です。")
        End Try


    End Sub

    Private Sub ButtonDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDown.Click
        Try
            TextBoxFscale.Text = CStr(CSng(TextBoxFscale.Text) / 2)
            TextBoxBscale.Text = CStr(CSng(TextBoxBscale.Text) / 2)
            ScaleSet()

        Catch ex As Exception
            MessageBox.Show("Error! 不適当な設定です。")
        End Try


    End Sub
End Class
